/// CoMath.cpp excerpt)
#define INITGUID
#include <afxdisp.h>
#include "CoMath.h"
#include "UUID.h"

IMPLEMENT_DYNCREATE(CoMath, CCmdTarget)

IMPLEMENT_OLECREATE(CoMath, "CoMath",
0xb6812840, 0x46e9, 0x11ce, 0xae, 0xff, 0xe7, 0x98, 0xa8, 0x72, 0x14, 0x16);


class CLib:public CWinApp {
   BOOL InitInstance() {
     AfxOleLockApp();
     return COleObjectFactory::RegisterAll();
   }
   int ExitInstance() {
     AfxOleUnlockApp();
     return 0;
   }
};

CLib lib;

BEGIN_INTERFACE_MAP(CoMath, CCmdTarget)
   INTERFACE_PART(CoMath, IID_IMath, MathObj)
   INTERFACE_PART(CoMath, IID_IPersist, PersistObj)
END_INTERFACE_MAP()

CoMath::CoMath(void) {

   TRACE0("In CoMath Constructor\n");


   AfxOleLockApp();
}

CoMath::~CoMath(void)
{
   TRACE0("CoMath::~CoMath() was called\n");
   AfxOleUnlockApp();
}

STDMETHODIMP_(ULONG) 
CoMath::XPersistObj::AddRef(void)
{
   METHOD_PROLOGUE(CoMath, PersistObj)
   return pThis->ExternalAddRef();
}

STDMETHODIMP_(ULONG) 
CoMath::XPersistObj::Release(void)
{
   METHOD_PROLOGUE(CoMath, PersistObj)
   return pThis->ExternalRelease();
}

STDMETHODIMP 
CoMath::XPersistObj::QueryInterface(REFIID riid, LPVOID FAR*ppv) {
   METHOD_PROLOGUE(CoMath, PersistObj)
   return pThis->ExternalQueryInterface(&riid, ppv);
}

// IPersist members
STDMETHODIMP 
CoMath::XPersistObj::GetClassID(LPCLSID pClsid)
{
   METHOD_PROLOGUE(CoMath, PersistObj)
	*pClsid = CLSID_CoMath;

	return NOERROR;
}


// IMath Members
STDMETHODIMP_(ULONG) 
CoMath::XMathObj::AddRef(void)
{
   METHOD_PROLOGUE(CoMath, MathObj)
   return pThis->ExternalAddRef();
}

STDMETHODIMP_(ULONG) 
CoMath::XMathObj::Release(void)
{
   METHOD_PROLOGUE(CoMath, MathObj)
   return pThis->ExternalRelease();
}

STDMETHODIMP 
CoMath::XMathObj::QueryInterface(REFIID riid, LPVOID FAR *ppv) {
   METHOD_PROLOGUE(CoMath, MathObj)
   return pThis->ExternalQueryInterface(&riid, ppv);
}


// IMath members
STDMETHODIMP 
CoMath::XMathObj::Add(INT n1, INT n2, LPLONG lpResult)
{
   METHOD_PROLOGUE(CoMath, MathObj)
   *lpResult = n1 + n2;
	return NOERROR;
}

STDMETHODIMP 
CoMath::XMathObj::Subtract(INT n1, INT n2, LPLONG lpResult)
{
   METHOD_PROLOGUE(CoMath, MathObj)
   *lpResult = n1 - n2;
	return NOERROR;
}

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
        AFX_MANAGE_STATE(AfxGetStaticModuleState());
        return AfxDllGetClassObject(rclsid, riid, ppv);
}

STDAPI DllCanUnloadNow(void)
{
        AFX_MANAGE_STATE(AfxGetStaticModuleState());
        return AfxDllCanUnloadNow();
}

// by exporting DllRegisterServer, you can use regsvr.exe
STDAPI DllRegisterServer(void)
{
        AFX_MANAGE_STATE(AfxGetStaticModuleState());
        COleObjectFactory::UpdateRegistryAll();
        return S_OK;
}