#ifndef _COMATHN_H
#define _COMATHN_H
#include "IMath.h"


class CoMath : public IUnknown{
private:
   DWORD m_dwRefCount;

public:
   CoMath();
   virtual ~CoMath();

   // IUnknown methods
   STDMETHODIMP_(DWORD) AddRef(void);
   STDMETHODIMP_(DWORD) Release(void);
   STDMETHODIMP QueryInterface(REFIID,
                               LPVOID FAR*);

   class PersistObj: public IPersist {
   public:
      CoMath* m_pParent;

      STDMETHODIMP_(DWORD) AddRef(void);
      STDMETHODIMP_(DWORD) Release(void);
      STDMETHODIMP QueryInterface(REFIID,
                                  LPVOID FAR*);
      STDMETHODIMP GetClassID(LPCLSID pclsid);
   } m_persistObj;

   class MathObj: public IMath {
   public:
      CoMath* m_pParent;
      
      STDMETHODIMP_(DWORD) AddRef(void);
      STDMETHODIMP_(DWORD) Release(void);
      STDMETHODIMP QueryInterface(REFIID,
                                  LPVOID FAR*);

      STDMETHODIMP Add(INT, INT, LPLONG);
      STDMETHODIMP Subtract(INT, INT, LPLONG);
   } m_mathObj;
};


#endif //_COMATHN_H
