// dndedvw.cpp : implementation of the CDndeditView class
//

#include "stdafx.h"
#include "dndedit.h"

#include "dndeddoc.h"
#include "dndedvw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDndeditView

IMPLEMENT_DYNCREATE(CDndeditView, CEditView)

BEGIN_MESSAGE_MAP(CDndeditView, CEditView)
	//{{AFX_MSG_MAP(CDndeditView)
	ON_WM_LBUTTONDOWN()
	ON_WM_CREATE()
	ON_COMMAND(ID_EDIT_OLECOPY, OnEditOlecopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_OLECOPY, OnUpdateEditOlecopy)
	ON_COMMAND(ID_EDIT_OLEPASTE, OnEditOlepaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_OLEPASTE, OnUpdateEditOlepaste)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CEditView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDndeditView construction/destruction

CDndeditView::CDndeditView()
{
	m_bSelfDragging = FALSE;

}

CDndeditView::~CDndeditView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CDndeditView drawing

void CDndeditView::OnDraw(CDC* pDC)
{
	CDndeditDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CDndeditView printing

BOOL CDndeditView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default CEditView preparation
	return CEditView::OnPreparePrinting(pInfo);
}

void CDndeditView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CEditView begin printing.
	CEditView::OnBeginPrinting(pDC, pInfo);
}

void CDndeditView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CEditView end printing
	CEditView::OnEndPrinting(pDC, pInfo);
}

/////////////////////////////////////////////////////////////////////////////
// CDndeditView diagnostics

#ifdef _DEBUG
void CDndeditView::AssertValid() const
{
	CEditView::AssertValid();
}

void CDndeditView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}

CDndeditDoc* CDndeditView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDndeditDoc)));
	return (CDndeditDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDndeditView message handlers

void CDndeditView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CEdit& rEditCtrl = GetEditCtrl();
   int nStart = 0, nEnd = 0;
   rEditCtrl.GetSel(nStart, nEnd);

   if(nStart < nEnd) {
      // start doing dragging...
      m_bSelfDragging = TRUE;

      CString strSelected;

      strSelected.Empty();
      GetSelectedText(strSelected);

      COleDataSource cods;

      LPCSTR source = strSelected.GetBuffer(0);
      HGLOBAL h = GlobalAlloc(GHND | GMEM_SHARE, strlen(source) + 1);
      strcpy(LPSTR(GlobalLock(h)), source);
      GlobalUnlock(h);
      cods.CacheGlobalData(CF_TEXT, h);

      DROPEFFECT de = cods.DoDragDrop(DROPEFFECT_COPY | DROPEFFECT_MOVE);
      if ( de == DROPEFFECT_MOVE)
      {
         CString strEmpty;
         strEmpty.Empty();
         rEditCtrl.ReplaceSel(strEmpty);
		}
      
   } else {
	   CEditView::OnLButtonDown(nFlags, point);
   }
}

int CDndeditView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CEditView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_dt.Register(this);    	
	return 0;
}

DROPEFFECT CDndeditView::OnDragOver(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point) 
{
  DROPEFFECT de = DROPEFFECT_NONE;

  de = (dwKeyState & MK_CONTROL) 
           ? DROPEFFECT_COPY
           : DROPEFFECT_MOVE;

  return de;
}

DROPEFFECT CDndeditView::OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point) 
{
  DROPEFFECT de = DROPEFFECT_NONE;

  if (pDataObject->IsDataAvailable(CF_TEXT)) {
		de = (dwKeyState & MK_CONTROL) 
				? DROPEFFECT_COPY
				: DROPEFFECT_MOVE;
  }
  return de;
}

BOOL CDndeditView::OnDrop(COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point) 
{
  if ((dropEffect == DROPEFFECT_COPY || 
       dropEffect == DROPEFFECT_MOVE)) {

      OutputDebugString("In OnDrop\n");

      CString strDropText;

      HANDLE h = pDataObject->GetGlobalData(CF_TEXT);
      strDropText = LPCSTR(GlobalLock(h));
      GlobalUnlock(h);
      GlobalFree(h); 

      CEdit& rEditCtrl = GetEditCtrl();      
      if(m_bSelfDragging) {
         int nTextLen = rEditCtrl.GetWindowTextLength();
         rEditCtrl.SetSel(nTextLen, nTextLen, FALSE);
      }
      rEditCtrl.ReplaceSel(strDropText);

    }
    return TRUE;  
}

void CDndeditView::OnDragLeave() 
{
	m_bSelfDragging = FALSE;	
	CEditView::OnDragLeave();
}

void CDndeditView::OnEditOlecopy() 
{
   CEdit& rEditCtrl = GetEditCtrl();
   int nStart = 0, nEnd = 0;
   rEditCtrl.GetSel(nStart, nEnd);

   if(nStart < nEnd) {
      // something is selected...

      CString strSelected;

      strSelected.Empty();
      GetSelectedText(strSelected);

      LPCSTR source = strSelected.GetBuffer(0);

      COleDataSource *pcods;
      pcods = new COleDataSource;
      HGLOBAL h = GlobalAlloc(GHND | GMEM_SHARE, strlen(source) + 1);
      strcpy(LPSTR(GlobalLock(h)), source);
      GlobalUnlock(h);
      pcods->CacheGlobalData(CF_TEXT, h);
      pcods->SetClipboard();
   } 
}

void CDndeditView::OnUpdateEditOlecopy(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CDndeditView::OnEditOlepaste() 
{
  COleDataObject codo;

  codo.AttachClipboard();

  if (codo.IsDataAvailable(CF_TEXT))
		{
      HANDLE h = codo.GetGlobalData(CF_TEXT);

      CEdit& rEditCtrl = GetEditCtrl();      
      rEditCtrl.ReplaceSel(LPCSTR(GlobalLock(h)));
      GlobalUnlock(h);
      GlobalFree(h); 
				
      GetDocument()->UpdateAllViews(0);
      GetDocument()->SetModifiedFlag(TRUE);
   }

	codo.Release();
	
}

void CDndeditView::OnUpdateEditOlepaste(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}
